Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# CORBA_Object Class Reference

`#include <Object.h>`

Inheritance diagram for CORBA_Object

[legend]
Collaboration diagram for CORBA_Object:

[legend]
List of all members.

## Public Types
typedef CORBA_Object_ptr | _ptr_type
typedef CORBA_Object_var | _var_type
## Public Methods
virtual | ~CORBA_Object (void)
| Destructor.
virtual CORBA::Boolean | _is_a (const char *logical_type_id, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
| determine if we are of the type specified by the "logical_type_id".
virtual const char* | _interface_repository_id (void) const
| The repository ID for the most derived class, this is an implementation method and does no remote invocations!
virtual CORBA::Boolean | _is_collocated (void) const
| Is this object collocated with the servant?
virtual CORBA::Boolean | _is_local (void) const
| Is this a local object?
virtual TAO_Abstract_ServantBase* | _servant (void) const
virtual CORBA::Boolean | _non_existent (CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
virtual CORBA::ImplementationDef_ptr | _get_implementation ( CORBA_Environment &ACE_TRY_ENV = TAO_default_environment () )
| This method is deprecated in the CORBA 2.2 spec, we just return 0 every time.
virtual CORBA_InterfaceDef_ptr | _get_interface ( CORBA_Environment &ACE_TRY_ENV = TAO_default_environment () )
| Get info about the object from the Interface Repository.
virtual void | _create_request (CORBA::Context_ptr ctx, const char *operation, CORBA::NVList_ptr arg_list, CORBA::NamedValue_ptr result, CORBA::Request_ptr &request, CORBA::Flags req_flags, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
virtual void | _create_request (CORBA::Context_ptr ctx, const char *operation, CORBA::NVList_ptr arg_list, CORBA::NamedValue_ptr result, CORBA::ExceptionList_ptr exclist, CORBA::ContextList_ptr ctxtlist, CORBA::Request_ptr &request, CORBA::Flags req_flags, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
virtual CORBA::Request_ptr | _request (const char *operation, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
| DII operation to create a request.
CORBA::Policy_ptr | _get_policy ( CORBA::PolicyType type, CORBA::Environment &ACE_TRY_ENV = TAO_default_environment () )
CORBA::Policy_ptr | _get_client_policy ( CORBA::PolicyType type, CORBA::Environment &ACE_TRY_ENV = TAO_default_environment () )
CORBA::Object_ptr | _set_policy_overrides ( const CORBA::PolicyList & policies, CORBA::SetOverrideType set_add, CORBA::Environment &ACE_TRY_ENV = TAO_default_environment () )
CORBA::PolicyList* | _get_policy_overrides ( const CORBA::PolicyTypeSeq & types, CORBA::Environment &ACE_TRY_ENV = TAO_default_environment () )
CORBA::Boolean | _validate_connection ( CORBA::PolicyList_out inconsistent_policies, CORBA::Environment &ACE_TRY_ENV = TAO_default_environment () )
virtual CORBA::ULong | _hash (CORBA::ULong maximum, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
virtual CORBA::Boolean | _is_equivalent (CORBA::Object_ptr other_obj, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()) throw ()
virtual TAO_ObjectKey* | _key (CORBA_Environment &ACE_TRY_ENV)
| Return the object key as an out parameter. Caller should release return value when finished with it.
virtual const TAO_ObjectKey& | _object_key (void)
virtual void* | _tao_QueryInterface (ptr_arith_t type)
| Downcasting this object pointer to some other derived class. This QueryInterface stuff only work for local object.
virtual void | _add_ref (void)
| Increment the reference count.
virtual void | _remove_ref (void)
| Decrement the reference count.
| CORBA_Object (TAO_Stub *p = 0, CORBA::Boolean collocated = 0, TAO_Abstract_ServantBase *servant = 0)
virtual TAO_Stub* | _stubobj (void) const
| get the underlying stub object.
virtual void | _proxy_broker (TAO_Object_Proxy_Broker *proxy_broker)
| Sets the proxy broker.
virtual TAO_Object_Proxy_Broker* | _proxy_broker (void)
| Gets the proxy broker.
## Static Public Methods
CORBA_Object_ptr | _duplicate (CORBA_Object_ptr obj)
| Increment the ref count.
CORBA_Object_ptr | _nil (void)
| Return a NULL object.
ACE_INLINE_FOR_GNUC CORBA_Object_ptr | _narrow (CORBA_Object_ptr obj, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
| No-op it is just here to simplify some templates.
CORBA_Object_ptr | _unchecked_narrow (CORBA_Object_ptr obj, CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ())
void | _tao_any_destructor (void*)
| Used in the implementation of CORBA::Any.
CORBA::Boolean | is_nil_i (CORBA_Object_ptr obj)
| Uninlined part of the now-inlined CORBA::is_nil().
## Static Public Attributes
int | _tao_class_id = 0
| Address of this variable used in <_unchecked_narrow>.
## Protected Methods
| CORBA_Object (int dummy)
| Initializing a local object.
CORBA::ULong | _incr_refcnt (void)
| Increment the reference count.
CORBA::ULong | _decr_refcnt (void)
| Decrement the reference count.
## Protected Attributes
CORBA::Boolean | is_collocated_
| Flag to indicate collocation. It is 0 except for collocated objects.
TAO_Abstract_ServantBase* | servant_
| Servant pointer. It is 0 except for collocated objects.
CORBA::Boolean | is_local_
| Specify whether this is a local object or not.
TAO_Object_Proxy_Broker* | proxy_broker_
## Private Methods
| CORBA_Object (const CORBA_Object &)
CORBA_Object& | operator= (const CORBA_Object &)
## Private Attributes
TAO_Stub* | protocol_proxy_
CORBA::ULong | refcount_
| Number of outstanding references to this object.
TAO_SYNCH_MUTEX | refcount_lock_
| Protect the reference count, this is OK because we do no duplicates or releases on the critical path.

## Member Typedef Documentation

typedef CORBA_Object_ptr CORBA_Object::_ptr_type

| Reimplemented in CORBA_Current, CORBA_ConstructionPolicy, CORBA_LocalObject, CORBA_Policy, and CORBA_PolicyCurrent.

typedef CORBA_Object_var CORBA_Object::_var_type

| Reimplemented in CORBA_Current, CORBA_ConstructionPolicy, CORBA_LocalObject, CORBA_Policy, and CORBA_PolicyCurrent.

## Constructor & Destructor Documentation

CORBA_Object::~CORBA_Object ( | void )`[virtual]`

| Destructor.

CORBA_Object::CORBA_Object ( | TAO_Stub * protocol_proxy = 0,
| CORBA::Boolean collocated = 0,
| TAO_Abstract_ServantBase * servant = 0 )

ACE_INLINE CORBA_Object::CORBA_Object ( | int dummy )`[protected]`

| Initializing a local object.

CORBA_Object::CORBA_Object ( | const CORBA_Object & )`[private]`

## Member Function Documentation

void CORBA_Object::_add_ref ( | void )`[virtual]`

| Increment the reference count. Reimplemented in CORBA_LocalObject, and TAO_Local_RefCounted_Object.

virtual void CORBA_Object::_create_request ( | CORBA::Context_ptr ctx,
| const char * operation,
| CORBA::NVList_ptr arg_list,
| CORBA::NamedValue_ptr result,
| CORBA::ExceptionList_ptr exclist,
| CORBA::ContextList_ptr ctxtlist,
| CORBA::Request_ptr & request,
| CORBA::Flags req_flags,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

virtual void CORBA_Object::_create_request ( | CORBA::Context_ptr ctx,
| const char * operation,
| CORBA::NVList_ptr arg_list,
| CORBA::NamedValue_ptr result,
| CORBA::Request_ptr & request,
| CORBA::Flags req_flags,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

ACE_INLINE CORBA::ULong CORBA_Object::_decr_refcnt ( | void )`[protected]`

| Decrement the reference count.

ACE_INLINE CORBA_Object_ptr CORBA_Object::_duplicate ( | CORBA_Object_ptr obj )`[static]`

| Increment the ref count.

CORBA::Policy_ptr CORBA_Object::_get_client_policy ( | CORBA::PolicyType type,
| CORBA::Environment & ACE_TRY_ENV = TAO_default_environment () )

CORBA::ImplementationDef_ptr CORBA_Object::_get_implementation ( | CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

| This method is deprecated in the CORBA 2.2 spec, we just return 0 every time. Reimplemented in CORBA_LocalObject.

CORBA_InterfaceDef_ptr CORBA_Object::_get_interface ( | CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

| Get info about the object from the Interface Repository. Reimplemented in CORBA_LocalObject.

CORBA::Policy_ptr CORBA_Object::_get_policy ( | CORBA::PolicyType type,
| CORBA::Environment & ACE_TRY_ENV = TAO_default_environment () )

CORBA::PolicyList * CORBA_Object::_get_policy_overrides ( | const CORBA::PolicyTypeSeq & types,
| CORBA::Environment & ACE_TRY_ENV = TAO_default_environment () )

CORBA::ULong CORBA_Object::_hash ( | CORBA::ULong maximum,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

| Return a (potentially non-unique) hash value for this object. This method relies on the representation of the object reference's private state. Since that changes easily (when different ORB protocols are in use) there is no default implementation. Reimplemented in CORBA_LocalObject.

ACE_INLINE CORBA::ULong CORBA_Object::_incr_refcnt ( | void )`[protected]`

| Increment the reference count.

const char * CORBA_Object::_interface_repository_id ( | void ) const`[virtual]`

| The repository ID for the most derived class, this is an implementation method and does no remote invocations! Reimplemented in CORBA_Current, CORBA_ConstructionPolicy, TAO_ORBInitInfo, and CORBA_PolicyCurrent.

CORBA::Boolean CORBA_Object::_is_a ( | const char * logical_type_id,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

| determine if we are of the type specified by the "logical_type_id".

CORBA::Boolean CORBA_Object::_is_collocated ( | void ) const`[virtual]`

| Is this object collocated with the servant?

CORBA::Boolean CORBA_Object::_is_equivalent ( | CORBA::Object_ptr other_obj,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () ) throw ()`[virtual]`

| Try to determine if this object is the same as <other_obj>. This method relies on the representation of the object reference's private state. Since that changes easily (when different ORB protocols are in use) there is no default implementation.

CORBA::Boolean CORBA_Object::_is_local ( | void ) const`[virtual]`

| Is this a local object?

TAO_ObjectKey * CORBA_Object::_key ( | CORBA_Environment & ACE_TRY_ENV )`[virtual]`

| Return the object key as an out parameter. Caller should release return value when finished with it. Reimplemented in CORBA_LocalObject.

ACE_INLINE_FOR_GNUC CORBA_Object_ptr CORBA_Object::_narrow ( | CORBA_Object_ptr obj,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[static]`

| No-op it is just here to simplify some templates.

ACE_INLINE CORBA_Object_ptr CORBA_Object::_nil ( | void )`[static]`

| Return a NULL object. Reimplemented in CORBA_Current, CORBA_ConstructionPolicy, CORBA_LocalObject, CORBA_Policy, and CORBA_PolicyCurrent.

virtual CORBA::Boolean CORBA_Object::_non_existent ( | CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

| Reimplemented in CORBA_LocalObject.

const TAO_ObjectKey & CORBA_Object::_object_key ( | void )`[virtual]`

| Return a reference to the object key of profile in-use. If there's no in-use profile, then the program will probably crash. This method does not create a new copy.

TAO_Object_Proxy_Broker * CORBA_Object::_proxy_broker ( | void )`[virtual]`

| Gets the proxy broker.

void CORBA_Object::_proxy_broker ( | TAO_Object_Proxy_Broker * proxy_broker )`[virtual]`

| Sets the proxy broker.

void CORBA_Object::_remove_ref ( | void )`[virtual]`

| Decrement the reference count. Reimplemented in CORBA_LocalObject, and TAO_Local_RefCounted_Object.

CORBA::Request_ptr CORBA_Object::_request ( | const char * operation,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[virtual]`

| DII operation to create a request.

TAO_Abstract_ServantBase * CORBA_Object::_servant ( | void ) const`[virtual]`

CORBA::Object_ptr CORBA_Object::_set_policy_overrides ( | const CORBA::PolicyList & policies,
| CORBA::SetOverrideType set_add,
| CORBA::Environment & ACE_TRY_ENV = TAO_default_environment () )

ACE_INLINE TAO_Stub * CORBA_Object::_stubobj ( | void ) const`[virtual]`

| get the underlying stub object.

void * CORBA_Object::_tao_QueryInterface ( | ptr_arith_t type )`[virtual]`

| Downcasting this object pointer to some other derived class. This QueryInterface stuff only work for local object. Reimplemented in CORBA_Current, CORBA_ConstructionPolicy, TAO_ORBInitInfo, and CORBA_PolicyCurrent.

void CORBA_Object::_tao_any_destructor ( | void * x )`[static]`

| Used in the implementation of CORBA::Any. Reimplemented in CORBA_ConstructionPolicy, and CORBA_Policy.

CORBA_Object_ptr CORBA_Object::_unchecked_narrow ( | CORBA_Object_ptr obj,
| CORBA_Environment & ACE_TRY_ENV = TAO_default_environment () )`[static]`

CORBA::Boolean CORBA_Object::_validate_connection ( | CORBA::PolicyList_out inconsistent_policies,
| CORBA::Environment & ACE_TRY_ENV = TAO_default_environment () )

CORBA::Boolean CORBA_Object::is_nil_i ( | CORBA_Object_ptr obj )`[static]`

| Uninlined part of the now-inlined CORBA::is_nil().

CORBA_Object& CORBA_Object::operator= ( | const CORBA_Object & )`[private]`

## Member Data Documentation

int CORBA_Object::_tao_class_id = 0`[inline, static]`

| Address of this variable used in <_unchecked_narrow>. Reimplemented in CORBA_Current, CORBA_ConstructionPolicy, CORBA_Policy, and CORBA_PolicyCurrent.

CORBA::Boolean CORBA_Object::is_collocated_`[protected]`

| Flag to indicate collocation. It is 0 except for collocated objects.

CORBA::Boolean CORBA_Object::is_local_`[protected]`

| Specify whether this is a local object or not.

TAO_Stub * CORBA_Object::protocol_proxy_`[private]`

| Pointer to the protocol-specific "object" containing important profiling information regarding this proxy. The protocol proxy is (potentially) shared among several CORBA_Objects

TAO_Object_Proxy_Broker * CORBA_Object::proxy_broker_`[protected]`

| Pointer to the Proxy Broker i.e. the instance that takes care of getting the right proxy for performing a given call.

CORBA::ULong CORBA_Object::refcount_`[private]`

| Number of outstanding references to this object.

TAO_SYNCH_MUTEX CORBA_Object::refcount_lock_`[private]`

| Protect the reference count, this is OK because we do no duplicates or releases on the critical path.

TAO_Abstract_ServantBase * CORBA_Object::servant_`[protected]`

| Servant pointer. It is 0 except for collocated objects.

The documentation for this class was generated from the following files:

- Object.h
- Object.cpp
- Object.i